<?php

namespace Teknisa\CMP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService {
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function CARREGA_PERIFORN($cdfilial, $cdforneced, $dtprogentaf, $newdt) {
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'CARREGA_PERIFORN');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFORNECED', Param::PARAM_INPUT, $cdforneced, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTPROGENTAF', Param::PARAM_INPUT, $dtprogentaf, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NEW_DTPROGENTAF', Param::PARAM_INPUT, $newdt, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    public function AJUSTE_CONTPREVISTA($cdfildest, $cdfillanc, $nrautoforn) {
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'AJUSTE_CONTPREVISTA');
        $procedure->addParam(new Param('P_CDFILDEST', Param::PARAM_INPUT, $cdfildest, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC', Param::PARAM_INPUT, $cdfillanc, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAUTOFORN', Param::PARAM_INPUT, $nrautoforn, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    public function CUSTO_AF($cdfildest, $cdfillanc, $nrautoforn, $nrseqapuraf) {
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'CUSTO_AF');
        $procedure->addParam(new Param('P_CDFILDEST', Param::PARAM_INPUT, $cdfildest, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC', Param::PARAM_INPUT, $cdfillanc, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAUTOFORN', Param::PARAM_INPUT, $nrautoforn, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPURAF', Param::PARAM_INPUT, $nrseqapuraf, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
}