<?php
namespace Teknisa\CMP\Modules\NecessidadeCompras\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Setforms2\Shared\ORM\DateTime;
use Exception;

class Cmp03800PreviaDoCalculoDaNecessidadeDeCompras extends \Teknisa\GER\Controllers\TeknisaCrud 
{
    
    protected $environment;
    protected $dataSourceManager;
	protected $connection;
	protected $newCode;
    public $central; 
    public $grupo;
    public $cardapio; 
    public $dados;  
    public $deleteReg;
    public $limi;
    public $calen;
        
    public function __construct( $crudService, $environment, $dataSourceManager, $connection,$newCode) 
    {
		$this->environment = $environment;
		$this->dataSourceManager = $dataSourceManager;
        $this->connection = $connection;
        $this->newCode = $newCode;
	}
	
	public function completaProd($campo)
    {
        return str_pad($campo, 20, 'Z', STR_PAD_RIGHT);
    }
	
	
	public function retornaParcmpsupPrevia(DTO\Request\Row $request, DTO\Response $response)
	{
	    $params = array(
    		"P_CDFILIAL" => $this->environment->getCdFilial(),
    		"NRORG" => $this->environment->getNrorg()
    	);
    	
    	$sql = "SELECT IDCALPREVCON, IDPERACRNEC, IDPERCESTNEC, NVL(IDSCONESTNEC, 'N') AS IDSCONESTNEC FROM PARCMPSUP WHERE CDFILIAL = :P_CDFILIAL AND NRORG = :NRORG";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    	$parcmpsup = $query->fetchAll();
    	
    	$response->addDataSet(new DataSet("parcmpsupPrevia", $parcmpsup));
    }
    
    public function retornaParametrosPrevia(DTO\Request\Row $request, DTO\Response $response)
    {
        $resp['IDSISDOS'] = self::retornaIdsisdos();
        $resp['CDGRUPPROD'] = self::selectGrupo();

        $response->addDataSet(new DataSet("parametrosPrevia", $resp));
    }
    
    public function selectGrupo() 
    {
        $params = array(
            "P_CDFILIAL" => $this->environment->getCdFilial(),
            "NRORG"      => $this->environment->getNrorg()
        );
        
        $sql = "SELECT PARASUPRI.CDGRUPPROD FROM PARASUPRI JOIN FILIAL ON PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AND PARASUPRI.NRORG = FILIAL.NRORG WHERE FILIAL.CDFILIAL = :P_CDFILIAL AND PARASUPRI.NRORG = :NRORG";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $cdgrupprod = $query->fetchAll();
        
        return (is_array($cdgrupprod) && !is_null($cdgrupprod)) ? (count($cdgrupprod) ? $cdgrupprod[0]['CDGRUPPROD'] : false) : false;
    }
    
    public function retornaIdsisdos() 
    {
        $params = array(
    		"NRORG" => $this->environment->getNrorg()
    	);
    	
    	$sql = "SELECT IDSISDOS FROM PARAMGERAL WHERE NRORG = :NRORG";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    	$idsisdos = $query->fetchAll();
    	
    	return (is_array($idsisdos) && !is_null($idsisdos)) ? (count($idsisdos) ? $idsisdos[0]['IDSISDOS'] : 1) : 1;
    }
    
    public function NECESSIDADE_DE_COMPRAS($cdfilial, $tcdfilial, $dtinicial, $dtfinal, $cdprodini, $cdprodfin, $peacrescimo, $idqtdezero, $code, $cdsubgrupo, $valGrupo) {
        $dtmoment = new \DateTime();
        $dtmoment = $dtmoment->format('d/m/Y H:i:s'); 
        $procedure = new StoredProcedure($this->connection, 'NECESSIDADE_DE_COMPRAS');
        
        $procedure->addParam(new Param('P_CDFILIAL',    Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL',   Param::PARAM_INPUT, $tcdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRUPFILI',  Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL',   Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL',     Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODINI',   Param::PARAM_INPUT, $cdprodini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODFIN',   Param::PARAM_INPUT, $cdprodfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',  Param::PARAM_INPUT, $this->environment->getCdoperador(), Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTHRCALCNC',  Param::PARAM_INPUT, $dtmoment, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDQTDEZERO',  Param::PARAM_INPUT, $idqtdezero, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRNECECOMP',  Param::PARAM_INPUT, $code, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_EXTRA',       Param::PARAM_INPUT, 'N', Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSUBGRUPO',  Param::PARAM_INPUT, $cdsubgrupo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRUPPROD',  Param::PARAM_INPUT, $valGrupo, Param::PARAM_TYPE_STR));
     
        $procedure->execute();
    }
    
    public function ExecStpNeceCompra(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $cdfilial    = $row['CDFILIAL'];
        $tcdfilial   = $row['TCDFILIAL'];
        $dtinicial   = $row['DTENTREGA']['start'];
        $dtfinal     = $row['DTENTREGA']['end'];
        $cdprodini   = $row['CDPRODINICIAL'];
        $cdprodfin   = $row['CDPRODFINAL'];
        $peacrescimo = isset($row['PEACRESCIMO']) ? $this->parseFloat($row['PEACRESCIMO']) : 0;
        $idqtdezero  = $row['MANTERPRODQTZERO'];
        $cdsubgrupo  = $row['CDSUBGRPROD'];
        $valGrupo    = self::selectGrupo();
     
        $code = $this->newCode->getCodeByTableName("NECECOMP", $this->environment->getNrOrg());
        
        $this->NECESSIDADE_DE_COMPRAS($cdfilial, $tcdfilial, $dtinicial, $dtfinal, $cdprodini, $cdprodfin, $peacrescimo, $idqtdezero, $code, $cdsubgrupo, $valGrupo);

        return $code;
    }
    
    public function proceNecessidadeCompras(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $stNrNeceComp = $this->ExecStpNeceCompra($request, $response);
            
           
            $response->addDataSet(new DataSet('response', array($stNrNeceComp)));
            if (empty($stNrNeceComp) == false && strlen($stNrNeceComp) <> 10) {
                
                $mensagem = "O código deve possuir tamanho 10 :".strlen($stNrNeceComp);
				
                throw new \Exception($mensagem); 
            }
        }
        catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function procePeriodicidadeNaoCalculada(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if($row['CALENDARIO'] == 'S') {
            $this->PERIODICIDADE_NAO_CALCULADA($row['CDFILIAL'], $row['TCDFILIAL'], null, $row['CDPRODINICIAL'], $row['CDPRODFINAL']);
        }
    }
    
    public function PERIODICIDADE_NAO_CALCULADA($cdfilial, $tcdfilial, $groupFili, $prodini, $prodfin) {
        $procedure = new StoredProcedure($this->connection, 'PERIODICIDADE_NAO_CALCULADA');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial,Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $tcdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRUPFILI', Param::PARAM_INPUT, $groupFili, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODINI', Param::PARAM_INPUT, $prodini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODFIN', Param::PARAM_INPUT, $prodfin, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    
    public function getParamGeral()
    {
        $params = array(
            "NRORG" => $this->environment->getNrorg()
        );
        
        $sql = "SELECT IDSISDOS FROM PARAMGERAL WHERE NRORG = :NRORG";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $this->calen = $query->fetchAll();
    }
    
    public function dataLimiteSeguranca(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
    
        $data = self::calculaDataLimiteSeguranca($row['CDFILIAL'], $row['CDPRODINICIAL'], $row['CDPRODFINAL'], null, $row['DTENTREGA']['end']);
    
        $resposta['DATSEGU'] = $data->format('d/m/Y');
    
        $response->addDataSet(new DataSet("resposta", $resposta));
    }
    
    public function calculaDataLimiteSeguranca($cdfilial, $cdprodini, $cdprodfin, $groupfili, $data) 
    {
        self::selectGetLimiSegu($cdfilial, $cdprodini, $cdprodfin, $groupfili);
    
        $data = str_replace("/", "-", $data);
        $data = new DateTime($data);
        $data->add(new \DateInterval('P01M'));
        $diaSeguranca = $this->limi[0]['MAXLIMISEG'] ? $this->limi[0]['MAXLIMISEG'] : 0;
        $data->add(new \DateInterval('P' . $diaSeguranca . 'D'));
        
        return $data;
    }
    
    public function selectGetLimiSegu($cdfilial, $cdprodini, $cdprodfin, $groupfili)
    {
        $params = array(
            "P_CDGRUPFILI" => $groupfili,
            "P_CDFILIAL" => $cdfilial,
            "P_CDPRODUTOINI" => $cdprodini,
            "P_CDPRODUTOFIN" => $cdprodfin = self::completaProd($cdprodfin),
            "NRORG" => $this->environment->getNrorg()
        );
    
        $sql = "SELECT MAX(NRLIMISEGU) AS MAXLIMISEG FROM (SELECT CDFILIAL, NRORG FROM FILGRUPFILI WHERE (FILGRUPFILI.CDGRUPFILI = :P_CDGRUPFILI) AND (NRORG = :NRORG) AND (INSTR(:P_CDFILIAL, FILGRUPFILI.CDFILIAL) > 0 OR :P_CDFILIAL = 'T') UNION SELECT CDFILIAL, NRORG FROM FILIAL WHERE (:P_CDGRUPFILI IS NULL) AND (NRORG = :NRORG) AND (INSTR(:P_CDFILIAL, FILIAL.CDFILIAL) > 0 OR :P_CDFILIAL = 'T')) FILGRUPFILI, LIMISEGPROD, (SELECT CDPRODUTO, NRORG FROM PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND NRORG = :NRORG UNION SELECT CDPRODUTO, NRORG FROM PRODUTO WHERE :P_CDPRODUTOINI LIKE PRODUTO.CDARVPROD||'%' AND NRORG = :NRORG) PRODUTO WHERE (LIMISEGPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND (LIMISEGPROD.NRORG = PRODUTO.NRORG) AND (FILGRUPFILI.CDFILIAL = LIMISEGPROD.CDFILIAL) AND (FILGRUPFILI.NRORG = LIMISEGPROD.NRORG)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $this->limi = $query->fetchAll();
    }
    
    public function GetPrxConsPlan(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $acrescimo = isset($row['PEACRESCIMO']) ? $this->parseFloat($row['PEACRESCIMO']) : 0; 
        $servico = $this->adqParamServico( $row['CDFILIAL'], null);
            
        if(((is_array($servico) && !is_null($servico)) ? count($servico) : 0) != 0){
            $resposta['MSG'] = $row['MSGBACK'];
            $response->addDataSet(new DataSet("resposta", $resposta));
        } else {
            $this->CALCULA_PREVCONS_FILIAIS($row['CDFILIAL'],  $row['CDFILIAL'], null, $row['DATFIMSEGU'], $acrescimo, $row['CDPRODINICIAL'], $row['CDPRODFINAL']);
            $resposta['MSG'] = null;
            $response->addDataSet(new DataSet("resposta", $resposta));
        }     
    }
    
    public function parseFloat($floatVar)
    {
           if(is_string($floatVar)){
                $floatVar = str_replace(".", "", $floatVar); 
                $floatVar = str_replace(",", ".", $floatVar);
           }
           return $floatVar;
    }
    
    public function adqParamServico($cdfilial, $groupFili)
    {
        $params = array(
            "P_CDGRUPFILI" => $groupFili,
            "P_CDFILIAL" => $cdfilial,
        );
    
        $sql = "SELECT PARAMPLANEJA.CDFILIAL FROM SERVICO, PARAMPLANEJA, (SELECT FILIAL.CDFILIAL FROM FILIAL WHERE (INSTR(:P_CDFILIAL, FILIAL.CDFILIAL) > 0 OR :P_CDFILIAL = 'T') AND (:P_CDGRUPFILI IS NULL) UNION SELECT FILGRUPFILI.CDFILIAL FROM FILGRUPFILI WHERE (INSTR(:P_CDFILIAL, FILGRUPFILI.CDFILIAL) > 0 OR :P_CDFILIAL = 'T') AND (FILGRUPFILI.CDGRUPFILI = :P_CDGRUPFILI)) FILIAL WHERE (SERVICO.CDFILIAL = FILIAL.CDFILIAL) AND (NVL(SERVICO.IDUTRETIPRAT, 'N') = 'S') AND (PARAMPLANEJA.CDFILIAL = SERVICO.CDFILIAL) AND (NVL(PARAMPLANEJA.IDUTREQUPRAT, 'N') = 'N') AND (CDTPRCONSFIX IS NULL OR CDPRACONSFIX IS NULL OR CDTPRCONSPER IS NULL OR CDPRACONSPER IS NULL) UNION SELECT PARAMPLANEJA.CDFILIAL FROM PARAMPLANEJA, (SELECT FILIAL.CDFILIAL FROM FILIAL WHERE (INSTR(:P_CDFILIAL, FILIAL.CDFILIAL) > 0 OR :P_CDFILIAL = 'T') AND (:P_CDGRUPFILI IS NULL) UNION SELECT FILGRUPFILI.CDFILIAL FROM FILGRUPFILI WHERE (INSTR(:P_CDFILIAL, FILGRUPFILI.CDFILIAL) > 0 OR :P_CDFILIAL = 'T') AND (FILGRUPFILI.CDGRUPFILI = :P_CDGRUPFILI)) FILIAL WHERE (PARAMPLANEJA.CDFILIAL = FILIAL.CDFILIAL) AND (NVL(IDUTREQUPRAT, 'N') = 'S') AND (CDTPRCONSFIX IS NULL OR CDPRACONSFIX IS NULL OR CDTPRCONSPER IS NULL OR CDPRACONSPER IS NULL)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    public function CALCULA_PREVCONS_FILIAIS($cdfilial , $tcdfilial, $groupFili, $datfin, $acrescimo, $prodini, $prodfin) 
    {
        $date = new DateTime();
        $date = $date->format('d/m/Y H:i:s');
       
        $procedure = new StoredProcedure($this->connection, 'CALCULA_PREVCONS_FILIAIS');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial,Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $tcdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRUPFILI', Param::PARAM_INPUT, $groupFili, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $datfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PEACRESCIMO', Param::PARAM_INPUT, $acrescimo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, $prodini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, $prodfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $this->environment->getCdoperador(), Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTHRCALCPC', Param::PARAM_INPUT, $date, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDARREDOND', Param::PARAM_INPUT, 'N', Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_STDTFINAL', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_STDTINICIAL', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }

}
