<?php
namespace Teknisa\CMP\Modules\V1\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class NecessidadeCompra{

    protected $entityManager;

    const SQL_REMOVE_NECESSIDADE_POR_DATA = "DELETE FROM TRABNECECOMP WHERE NRNECECOMP = ? AND DTENTRNECCMP = ? AND CDFILNECECMP = ? AND NRORG = ?";
    const SQL_REMOVE_NECESSIDADE_POR_PRODUTO = "DELETE FROM TRABNECECOMP WHERE NRNECECOMP = ? AND CDPRODNECCMP = ? AND CDFILNECECMP = ? AND NRORG = ?";
    const SQL_REMOVE_TODAS_NECESSIDADES = "DELETE FROM TRABNECECOMP WHERE NRNECECOMP = ? AND NRORG = ?";

    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function removeNecessidadePorData($nrNeceComp, $dtEntrNecCmp, $cdFilNeceCmp, $nrorg){
        $st = $this->entityManager->getConnection()->prepare(self::SQL_REMOVE_NECESSIDADE_POR_DATA);
        $params = array($nrNeceComp, $dtEntrNecCmp, $cdFilNeceCmp, $nrorg);
        $st->execute($params);
    }

    public function removeNecessidadePorProduto($nrNeceComp, $cdProdNecCmp, $cdFilNeceCmp, $nrorg){
        $st = $this->entityManager->getConnection()->prepare(self::SQL_REMOVE_NECESSIDADE_POR_DATA);
        $params = array($nrNeceComp, $cdProdNecCmp, $cdFilNeceCmp, $nrorg);
        $st->execute($params);
    }

    public function removeTodasNecessidades($nrNeceComp, $nrorg){
        $st = $this->entityManager->getConnection()->prepare(self::SQL_REMOVE_TODAS_NECESSIDADES);
        $params = array($nrNeceComp, $nrorg);
        $st->execute($params);
    }

    public function proceGeraSolicitacao($cdfillanc, $nrnececomp, $operador, $extra){
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'GERA_SOLICITACAO');
        $procedure->addParam(new Param('P_CDFILILANC', Param::PARAM_INPUT, $cdfillanc, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRNECECOMP', Param::PARAM_INPUT, $nrnececomp, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERLANC', Param::PARAM_INPUT, $operador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_EXTRA', Param::PARAM_INPUT, $extra, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_MSGEXTRA', Param::PARAM_INPUT, 'Cálculo da Necessidade de Compras - Extra', Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
}